<!DOCTYPE html>
    <html lang="en">
    <head>
        <meta charset="UTF-8">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">

        <!--=============== BOXICONS ===============-->
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/boxicons@latest/css/boxicons.min.css">

        <!--=============== CSS ===============-->
        <link rel="stylesheet" href="assets/css/styles.css">
        <!--=============== Julie CSS ===============-->
        <title>FARMWISE IOT PLATFORM</title>
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        <script src="https://code.highcharts.com/highcharts.js"></script>
        <script src="js/mqttws31.js" type="text/javascript"></script>
        <script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>
        <script src="js/config.js" type="text/javascript"></script>
        <link rel="stylesheet" type="text/css" href="https://cdn.jsdelivr.net/npm/daterangepicker/daterangepicker.css" />
        <script type="text/javascript" src="https://cdn.jsdelivr.net/npm/daterangepicker/daterangepicker.min.js"></script>
      <!-- Add the font-awesome stylesheet to the head of your HTML -->
      <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
      <link rel="stylesheet"href="https://unpkg.com/leaflet@1.7.1/dist/leaflet.css"/>
        <script src="https://unpkg.com/leaflet@1.7.1/dist/leaflet.js"></script>
         <!-- Bootstrap CSS -->
     <!-- <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/css/bootstrap.min.css">-->

      <style>

          .widget-container {
            display: flex;
            flex-wrap: wrap;
            justify-content: space-between;
            width: 100%;
            max-width: 1200px;
            margin: 0 auto;
          }

          .temp-widget {
            flex-basis: calc((100% - 30px) / 4); /* 4 widgets in the first row */
            margin-bottom: 20px;
            background-color: #ffffff;
            padding: 10px;
            border: 1px solid #e3e3e3;
            text-align: center;
          }

          @media (max-width: 991px) {
            .temp-widget {
              flex-basis: calc((100% - 20px) / 3); /* 3 widgets in the second row */
            }
          }

          @media (max-width: 767px) {
            .temp-widget {
              flex-basis: calc((100% - 10px) / 2); /* 2 widgets in each row */
            }
          }
          
          .container2 {
          display: flex;
          flex-direction: row;
        }

        #mapid {
          height: 250px;
          width: 40%;
        }

        #pestdetection {
          width: 50%;
          margin-left: 20px; /* add margin to the left */
        }
              </style>
    </head>
    <body>
        <!--=============== HEADER ===============-->
        <header class="header" id="header">
            <nav class="nav container">
                <a href="#" class="nav__logo">FarmWise</a>

                <div class="nav__menu" id="nav-menu">
                    <ul class="nav__list">
                        <li class="nav__item">
                            <a href="#home" class="nav__link active-link">
                                <i class='bx bx-home-alt nav__icon'></i>
                                <span class="nav__name">Home</span>
                            </a>
                        </li>
                        
                        <li class="nav__item">
                            <a href="controls.html" class="nav__link">
                                <i class='bx bx-user nav__icon'></i>
                                <span class="nav__name">Controls</span>
                            </a>
                        </li>

                        <li class="nav__item">
                             <a href="predictions.html" class="nav__link">
                                <i class='bx bx-book-alt nav__icon'></i>
                                <span class="nav__name">Predictions</span>
                            </a>
                        </li>
                      <li class="nav__item">
                             <a href="rover.html" class="nav__link">
                                <i class='bx bx-book-alt nav__icon'></i>
                                <span class="nav__name">Rover</span>
                            </a>
                        </li>
                        <li class="nav__item">
                            <a href="controls.html" class="nav__link">
                                <i class='bx bx-message-square-detail nav__icon'></i>
                                <span class="nav__name">Control Pump</span>
                            </a>
                        </li>
                    </ul>
                </div>

                <img src="assets/img/perfil.png" alt="" class="nav__img">
            </nav>
        </header>

        <main>
            <!--=============== HOME ===============-->
            <section class="container section section__height" id="home">
                <!--<h2 class="section__title">Home</h2>-->
  <div class="temp-widget">
              <span class="label">Node01</span>
              <span class=" widget-value">Front Yard</span>
            </div>
          <div class="widget-container">
          <div class="temp-widget">
              <i class="fa fa-thermometer-empty"></i>
              <span class="label">Air Temp</span>
              <span class=" widget-value temp-data">25°C</span>
            </div>
            <div class="temp-widget">
             <i class="fa fa-fire"></i>
              <span class="label">Air Humidity</span>
              <span class=" widget-value humid-data">25°C</span>
            </div>
            <div class="temp-widget">
              <i class="fa fa-thermometer-empty"></i>
              <span class="label">Soil Moisture</span>
              <span class="widget-value soil-data">25°C</span>
            </div>
            <div class="temp-widget">
              <i class="fa fa-thermometer-empty"></i>
              <span class="label">Soil Temp</span>
              <span class="widget-value tempCelsius-data">25°C</span>
            </div>
            <div class="temp-widget">
              <i class="fa fa-thermometer-empty"></i>
              <span class="label">Soil Salt</span>
              <span class="widget-value salt-data">25°C</span>
            </div>
            <div class="temp-widget">
              <i class="fa fa-thermometer-empty"></i>
              <span class="label">Light Intensity</span>
              <span class="widget-value light-data">25°C</span>
            </div>
            <div class="temp-widget">
              <i class="fa fa-thermometer-empty"></i>
              <span class="label">Battery Life</span>
              <span class="widget-value batt-data">25°C</span>
            </div>
            </div> 
           <div id="main-container">Main Container</div>
          <form name="chartform" id="date-form">
            <div>
              <label for="start-date">Start Date:</label>
              <input type="date" id="start-date" name="start-date">
            </div>
            <div>
              <label for="end-date">End Date:</label>
              <input type="date" id="end-date" name="end-date">
            </div>
            <button id="submit">Submit</button>
          </form>
        
          <label for="toggle-switch">Toggle between live MQTT data and historical data views</label>
          <input type="checkbox" id="toggle-switch" name="toggle-switch"></input>
          <div id="chart-container"></div>
          <div id="live-data-container"></div>
          <div id="atmospheric-chart" class="chart-container"></div>
           <div id="container"></div>
           
      <div id="weather"></div>
     <script type="text/javascript">
      var chart;
      var mqtt;
     
      var topic = "farmwise/node01/sensors/data"; // Specify the topic here //
      
      var responseObject = {}; // define responseObject variable
      var reconnectTimeout = 2000;

 
    function MQTTconnect() {
	if (typeof path == "undefined") {
		path = '/mqtt';
	}
	mqtt = new Paho.MQTT.Client(
			host,
			port,
			path,
			"web_" + parseInt(Math.random() * 100, 10)
	);
        var options = {
            timeout: 3,
            useSSL: useTLS,
            cleanSession: cleansession,
            onSuccess: onConnect,
            onFailure: function (message) {
                $('#status').val("Connection failed: " + message.errorMessage + "Retrying");
                setTimeout(MQTTconnect, reconnectTimeout);
            }
        };

        mqtt.onConnectionLost = onConnectionLost;
        mqtt.onMessageArrived = onMessageArrived;

        if (username != null) {
            options.userName = username;
            options.password = password;
        }
        console.log("Host="+ host + ", port=" + port + ", path=" + path + " TLS = " + useTLS + " username=" + username + " password=" + password);
        mqtt.connect(options);
    }
 var atmosphericChart;
function onConnect() {

    
    $('#status').val('Connected to ' + host + ':' + port + path);
    // Connection succeeded; subscribe to our topic
    mqtt.subscribe(topic, {qos: 0});
    $('#topic2').val(topic);


   atmosphericChart = createChart('atmospheric-chart', 'Atmospheric Data', 'Temperature', 'Humidity');
    // Set up chart
    chart = Highcharts.chart('container', {
      chart: {
        type: 'line',
        turboThreshold: 10000, // set to 0 to disable thresholding and display all points
         scrollablePlotArea: {
          minWidth: 600,
          scrollPositionX: 1
        }
      },
      title: {
        text: 'Sensor Data'
      },
      xAxis: {
        type: 'datetime',
        title: {
          text: 'Timestamp'
        }
      },
      yAxis: [{
        title: {
          text: 'Temperature'
        }
      }, {
        title: {
          text: 'Humidity'
        },
        opposite: true // display on opposite side of chart
      }, {
        title: {
          text: 'Soil Moisture'
        },
        opposite: true // display on opposite side of chart
      },
      {
        title: {
          text: 'Soil Temp'
        },
        opposite: true // display on opposite side of chart
      },
      {
        title: {
          text: 'Salt'
        },
        opposite: true // display on opposite side of chart
      }, {
        title: {
          text: 'Light'
        },
        opposite: true // display on opposite side of chart
      }, {
        title: {
          text: 'Battery'
        },
        opposite: true // display on opposite side of chart
      }],
      series: [{
        name: 'Temperature',
        data: [],
        yAxis: 0 // use the first yAxis (index 0) for this series
      }, {
        name: 'Humidity',
        data: [],
        yAxis: 1 // use the second yAxis (index 1) for this series
      }, {
        name: 'Soil Moisture',
        data: [],
        yAxis: 2 // use the third yAxis (index 2) for this series
      }, {
        name: 'Salt',
        data: [],
        yAxis: 3 // use the fourth yAxis (index 3) for this series
      }, {
        name: 'Light',
        data: [],
        yAxis: 4 // use the fifth yAxis (index 4) for this series
      }, {
        name: 'Battery',
        data: [],
        yAxis: 5 // use the sixth yAxis (index 5) for this series
      },
       {
        name: 'SoilTemp',
        data: [],
        yAxis: 6 // use the fifth yAxis (index 6) for this series
      }]
    });
}

 function createChart(containerId, title, ...yAxisTitles) {
    return Highcharts.chart(containerId, {
        chart: {
            type: 'line',
            turboThreshold: 10000,
            scrollablePlotArea: {
                minWidth: 600,
                scrollPositionX: 1
            }
        },
        title: {
            text: title
        },
        xAxis: {
            type: 'datetime',
            title: {
                text: 'Timestamp'
            }
        },
        yAxis: yAxisTitles.map((title, index) => ({
            title: {
                text: title
            },
            opposite: index % 2 !== 0 // display on opposite side of chart for every other yAxis
        })),
        series: yAxisTitles.map((title, index) => ({
            name: title,
            data: [],
            yAxis: index
        }))
    });
}
  function onConnectionLost(responseObject) {
  setTimeout(MQTTconnect, reconnectTimeout);
  $('#status').val("Connection lost: " + responseObject.errorMessage + ". Reconnecting");
}

const deviceContainers = {};

function onMessageArrived(message) {
  var topic = message.destinationName;
  var payload = message.payloadString;
  $('#ws').prepend('<li>' + topic + ' = ' + payload + '</li>');
  console.log("Message received: " + payload);
  
  // Parse message data
  var data = JSON.parse(payload);
  var timestamp = new Date().getTime();
  var deviceId = data.deviceId;
  var temp = parseFloat(data.atmtemp);
  var humid = parseFloat(data.atmhum);
  var soil = parseFloat(data.soilmoisture);
  var salt = parseFloat(data.soilsalt);
  var light = parseFloat(data.light);
  var batt = parseFloat(data.battlife);
  var tempCelsius = parseFloat(data.soiltemp);
  console.log(tempCelsius);
  
  //Widgets
  // Get all the temp-data elements in the widget container
// Get all the widget containers
const widgetContainers = document.querySelectorAll('.widget-container');

// Loop through each widget container and update the widget data
widgetContainers.forEach(widgetElement => {
  widgetElement.querySelector('.temp-data').textContent = data.atmtemp;
  
  // Update humidity data
  widgetElement.querySelector('.humid-data').textContent = data.atmhum;
  
  // Update soil data
  widgetElement.querySelector('.soil-data').textContent = data.soilmoisture;
  
  // Update salt data
  widgetElement.querySelector('.salt-data').textContent = data.soilsalt;
  
  // Update light data
 // widgetElement.querySelector('.light-data').textContent = data.light;
  
  // Update battery data
  widgetElement.querySelector('.batt-data').textContent = data.battlife;
  
  // Update soil data
  widgetElement.querySelector('.tempCelsius-data').textContent = data.soiltemp;
});

  chart.series[0].addPoint([Date.now(), data.atmtemp]);
  chart.series[1].addPoint([Date.now(), data.atmhum]);
  chart.series[2].addPoint([Date.now(), data.soilmoisture]);
  chart.series[3].addPoint([Date.now(), data.soilsalt]);
  chart.series[4].addPoint([Date.now(), data.light]);
  chart.series[5].addPoint([Date.now(), data.battlife]);
  chart.series[6].addPoint([Date.now(), data.soiltemp]);
  
  atmosphericChart.series[0].addPoint([timestamp, temp]);
  atmosphericChart.series[1].addPoint([timestamp, humid]);

  // Redraw the chart
  chart.redraw();
  atmosphericChart.redraw();
  
    // Update the device container with the latest readings
  //updateDeviceContainer(deviceId, deviceContainer, data);
  
  // Update the chart based on the toggle switch
  if ($("#toggle-switch").is(":checked")) {
    // Display historical data
    var startDate = new Date($("#start-date").val());
    var endDate = new Date($("#end-date").val());
    chart.xAxis[0].setExtremes(startDate.getTime(), endDate.getTime());
  } else {
    // Display live data
    chart.xAxis[0].setExtremes(); // Reset the x-axis extremes to display all data
  }
  
}



$(document).ready(function() {
  MQTTconnect();
});

function fetchData(start, end) {
  console.log('fetchData called with start:', start, 'end:', end);
  //const url = `/data/chart-data?start=${start.toISOString()}&end=${end.toISOString()}`; 
  const url = '/data/chart-data?start=2024-02-06T00:00:00.000Z&end=2024-02-08T00:00:00.000Z';
  console.log('fetchData url:', url);
  fetch(url)
    .then(response => response.json())
    .then(data => {
      console.log('fetchData data:', data);
      const chartData = data.map((obj) => ({
       // x: new Date(obj.msg.timestamp).getTime(),
       //y: [obj.msg.temp, obj.msg.humid, obj.msg.soil,obj.msg.tempCelsius, obj.msg.salt, obj.msg.light, obj.msg.batt],
        x: new Date(obj.timestamp).getTime(),
        y: [obj.temp, obj.humid, obj.soil, obj.salt, obj.light, obj.batt],
      }));
      console.log('fetchData chartData:', chartData);
      chart.series[0].setData(chartData.map(obj => [obj.x, obj.y[0]]));
      chart.series[1].setData(chartData.map(obj => [obj.x, obj.y[1]]));
      chart.series[2].setData(chartData.map(obj => [obj.x, obj.y[2]]));
      chart.series[3].setData(chartData.map(obj => [obj.x, obj.y[3]]));
      chart.series[4].setData(chartData.map(obj => [obj.x, obj.y[4]]));
      chart.series[5].setData(chartData.map(obj => [obj.x, obj.y[5]]));
      chart.series[6].setData(chartData.map(obj => [obj.x, obj.y[6]]));
    })
    .catch(error => console.error(error));
}

    function handleSubmit(event) {
        event.preventDefault();
        const start = new Date(document.getElementById('start-date').value);
        const end = new Date(document.getElementById('end-date').value);
        console.log(start, end);
        fetchData(start, end);
    }

    const myform = document.getElementById('date-form');
    myform.addEventListener('submit', handleSubmit);
    
    </script>
  
   <script>
    const pestform = document.querySelector('#pestForm');
    const responseDiv = document.querySelector('#response');
    const imageContainer = document.querySelector('#image-container');

    pestform.addEventListener('submit', async (event) => {
      event.preventDefault();
      responseDiv.innerHTML = 'Detecting pests...';
      imageContainer.innerHTML = '';

      const formData = new FormData(event.target);
      const response = await fetch('/detect', {
        method: 'POST',
        body: formData,
      });
      const data = await response.json();
      console.log(data);
      responseDiv.innerHTML = '';

     // if (data.pestsPresent) {
        const img = document.createElement('img');
        img.src = 'data:image/jpeg;base64,' + data.img;
        img.onload = () => {
          const canvas = document.createElement('canvas');
          /*canvas.width = img.width;
          canvas.height = img.height;*/
          canvas.width = 150;
          canvas.height = 150;
          const ctx = canvas.getContext('2d');
          ctx.drawImage(img, 0, 0,150,150);
          
          imageContainer.appendChild(canvas);
        };

        const p = document.createElement('p');
        p.textContent = ` Predicted diseases: ${data.diseases[0].disease}`;
        responseDiv.appendChild(p);
    });
    
    

  </script>

         <!--    <div>
      <div>Subscribed to <input type='text' id='topic2' disabled />
        Status: <input type='text' id='status' size="10" disabled /></div>
        <ul id='ws'"></ul>
        </div>-->
        <!-- Bootstrap JS -->
       <!-- <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/js/bootstrap.bundle.min.js"></script>-->
            </section>

            <!--=============== ABOUT ===============-->
           

            <!--=============== SKILLS ===============-->
            

            <!--=============== PORTFOLIO ===============-->
          
            <!--=============== CONTACTME ===============-->
           
        </main>
        

        <!--=============== MAIN JS ===============-->
        <script src="assets/js/main.js"></script>
    </body>
</html>